Attribute VB_Name = "modGraphics"
'Array Palette, like the array TColors, is an RGBTriplet
'You can use: Palette(index).Red
'             Palette(index).Green
'             Palette(index).Blue
' This works for TColors, too

Public Type RGBTriplet
    Red As Byte
    Green As Byte
    Blue As Byte
End Type
Public Type BITMAPFILEHEADER
    bfType As Integer
    bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOffBits As Long
End Type
Public Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Public TColors(2048) As RGBTriplet
Public Palette(256) As RGBTriplet
Public h1 As BITMAPFILEHEADER
Public h2 As BITMAPINFOHEADER

Sub getJASC(Palettefile As String)
    'Get palette from a 256 colors PAL (JASC - Paint Shop Pro format) file
    'Stores the palette in the array Palette

    Dim r As Integer, g As Integer, b As Integer, JascOrNot As String, e As Integer, index As Integer

    If UCase(Right(Dialog.filename, 3)) <> "PAL" Then Exit Sub

    index = FreeFile
    Open Palettefile For Input As #index
      Input #index, JascOrNot
      If JascOrNot <> "JASC-PAL" Then
          e = MsgBox("Not a valid JASC palette !", vbCritical)
	  Close #index
          Exit Sub
      End If
      Dim hundred As String, NbJascColor As String
      Input #index, hundred
      Input #index, NbJascColors
      If NbJascColors <> "256" Then
          e = MsgBox("Not a 256 colors JASC palette !", vbCritical)
	  Close #index
          Exit Sub
      End If
      For i = 0 To 255
          Input #index, r, g, b
          Palette(i + 1).Red = r
          Palette(i + 1).Green = g
          Palette(i + 1).Blue = b
      Next i
   Close #index
End Sub

Sub getPal(Palettefile As String)
    'Get palette from a 256 colors DIB or BMP file
    'Stores the palette in the array Palette

    If UCase(Right(Palettefile, 3)) <> "BMP" Or UCase(Right(Palettefile, 3)) <> "DIB" Then Exit Sub

    Dim r As Byte, g As Byte, b As Byte, a As Byte, e As Integer, NColors As Integer, index As Integer

    index = FreeFile
    Open Palettefile For Binary As #index
        Get #index, , h1
        Get #index, , h2
        If h2.biBitCount <> 8 Then
            e = MsgBox("Not a 8 bits palette (256 colors).", vbCritical)
	    Close #index
            Exit Sub
        Else
            NColors = 256
            For i = 1 To NColors
                Get #index, , b: Get #index, , g
                Get #index, , r: Get #index, , a
                Palette(i).Red = r
                Palette(i).Green = g
                Palette(i).Blue = b
            Next
        End If
    Close #index
End Sub

Sub makeTrueColors()
    'Creates a 2048 color palette and store it in TColor array

    For i = 0 To 255
        TColors(k).Red = i
        TColors(k).Green = 0
        TColors(k).Blue = 0
        k = k + 1
    Next

    For i = 0 To 255
        TColors(k).Red = 255
        TColors(k).Green = i
        TColors(k).Blue = 0
        k = k + 1
    Next

    For i = 0 To 255
        TColors(k).Red = 255
        TColors(k).Green = 255
        TColors(k).Blue = i
        k = k + 1
    Next

    For i = 255 To 0 Step -1
        TColors(k).Red = 255
        TColors(k).Green = i
        TColors(k).Blue = 255
        k = k + 1
    Next

    For i = 255 To 0 Step -1
        TColors(k).Red = i
        TColors(k).Green = 0
        TColors(k).Blue = 255
        k = k + 1
    Next

    For i = 0 To 255
        TColors(k).Red = 0
        TColors(k).Green = i
        TColors(k).Blue = 255
        k = k + 1
    Next

    For i = 255 To 0 Step -1
        TColors(k).Red = 0
        TColors(k).Green = 255
        TColors(k).Blue = i
        k = k + 1
    Next

    For i = 255 To 0 Step -1
        TColors(k).Red = 0
        TColors(k).Green = i
        TColors(k).Blue = 0
        k = k + 1
    Next

End Sub
